typedef unsigned char byte;
typedef unsigned int word;

class bytereg
{
public:
	byte value;
	bytereg() : value(0)
	{
	}
	bytereg(byte v) : value(v)
	{
	}
	byte operator++()    { return ++value; }
	byte operator--()    { return --value; }
	const byte &operator() () const { return value; }
}; 

static operator=(byte &dest, bytereg &src)
{
	dest = src.value;
}

static bytereg B,C,D,E, H,L, A,F, S,P;

class wordreg
{
	class bytereg &r1;
	class bytereg &r2;
	bytereg tmp1, tmp2;
public:
	wordreg(bytereg &reg1, bytereg &reg2) : r1(reg1), r2(reg2)
	{
	}
	wordreg(word v) : r1(tmp1), r2(tmp2), tmp1(v>>8), tmp2(v)
	{
	}
	word operator++()    { if(!++r1)++r2; return (r1.value<<8)|(r2.value); }
	word operator--()    { if(--r1==0xFF)--r2; return (r1.value<<8)|(r2.value); }
};

static wordreg BC(B,C), DE(D,E), HL(H,L), SP(S,P), AF(A,F);

static byte ADC(const bytereg &a, const bytereg &b)
{
}
static byte SBB(const bytereg &a, const bytereg &b)
{
}
static byte SHL(const bytereg &a, const bytereg &b)
{
}
static byte SHR(const bytereg &a, const bytereg &b)
{
}
static byte SAR(const bytereg &a, const bytereg &b)
{
}
static byte RCL(const bytereg &a, const bytereg &b)
{
}
static byte RCR(const bytereg &a, const bytereg &b)
{
}
static byte ROL(const bytereg &a, const bytereg &b)
{
}
static byte ROR(const bytereg &a, const bytereg &b)
{
}
static void JUMP(const wordreg &w)
{
}
static void STOP(const wordreg &b)
{
}
static void POKEW(const wordreg &w, const wordreg &v)
{
}
static byte &PEEK(const wordreg &w)
{	
	static byte tmp;
	return tmp;
}
void compile(const byte *data, unsigned pos, unsigned length, bool enterblock, unsigned endjump)
{
	const byte *dd = data;
	
	data += pos;
	
	const byte *max = data+length;
	
	while(data < max)
	{
		pos = data-dd;
		
    	byte b1 = data[1];
    	byte b2 = data[2];
    	
    	unsigned short w = b1 | ((unsigned)b2 << 8);
    	
    	if(*data==0x00) ;
    	else if(*data==0x10) { ++data; STOP(b1); }
    	
    	else if(*data==0x08) POKEW(w, SP);
    	
    	else if(*data==0x18) { ++data; JUMP(2+pos+(signed char)b1, false); /* JMP disp */ }
    	else if(*data==0xC3) { data+=2; JUMP(w); /* JMP abs */}
    	else if(*data==0xE9) JUMP(HL);
    	else if(*data==0xC2) { data+=2; if(!ZF)JUMP(w); }
    	else if(*data==0xD2) { data+=2; if(!CF)JUMP(w); }
    	else if(*data==0xCA) { data+=2; if(ZF)JUMP(w); }
    	else if(*data==0xDA) { data+=2; if(CF)JUMP(w); }
    	
    	else if(*data==0x20) { ++data; if(!ZF)JUMP(2+pos+(signed char)b1); /* JNZ disp */ }
    	else if(*data==0x30) { ++data; if(!CF)JUMP(2+pos+(signed char)b1); /* JNC disp */ }
    	else if(*data==0x28) { ++data; if(ZF)JUMP(2+pos+(signed char)b1); /* JZ disp */ }
    	else if(*data==0x38) { ++data; if(CF)JUMP(2+pos+(signed char)b1); /* JC disp */ }
    	
    	else if(*data==0x01) B=C;
    	else if(*data==0x11) D=E;
    	else if(*data==0x21) H=L;
    	else if(*data==0x31) S=P;
    	
    	else if(*data==0x02) PEEK(BC) = A;
    	else if(*data==0x12) PEEK(DE) = A;
    	else if(*data==0x22) PEEK(HL++) = A;
    	else if(*data==0x32) PEEK(HL--) = A;

    	else if(*data==0x03) ++BC;
    	else if(*data==0x13) ++DE;
    	else if(*data==0x23) ++HL;
    	else if(*data==0x33) ++SP;
    	
    	else if(*data==0x0B) --BC;
    	else if(*data==0x1B) --DE;
    	else if(*data==0x2B) --HL;
    	else if(*data==0x3B) --SP;
    	
    	else if(*data==0x04) ++B;
    	else if(*data==0x0C) ++C;
    	else if(*data==0x14) ++D;
    	else if(*data==0x1C) ++E;
    	else if(*data==0x24) ++H;
    	else if(*data==0x2C) ++L;
    	else if(*data==0x34) ++PEEK(HL);
    	else if(*data==0x3C) ++A;
    	
    	else if(*data==0x05) --B;
    	else if(*data==0x0D) --C;
    	else if(*data==0x15) --D;
    	else if(*data==0x1D) --E;
    	else if(*data==0x25) --H;
    	else if(*data==0x2D) --L;
    	else if(*data==0x35) --PEEK(HL);
    	else if(*data==0x3D) --A;
    	
    	else if(*data==0x06) { ++data; B=b1; }
    	else if(*data==0x16) { ++data; D=b1; }
    	else if(*data==0x26) { ++data; H=b1; }
    	else if(*data==0x36) { ++data; PEEK(HL) = b1; }
    	
    	else if(*data==0x07) { A = RCL(A); }
    	else if(*data==0x17) { A = ROL(A); }
    	else if(*data==0x27) { A = DAA(A); }
    	else if(*data==0x37) { CF = 1; }

    	else if(*data==0x09) HL += BC;
    	else if(*data==0x19) HL += DE;
    	else if(*data==0x29) HL += HL;
    	else if(*data==0x39) HL += SP;    	
    	
    	else if(*data==0x0A) A = PEEK(BC);
    	else if(*data==0x1A) A = PEEK(DE);
    	else if(*data==0x2A) A = PEEK(HL++);
    	else if(*data==0x3A) A = PEEK(HL--);
    	
    	else if(*data==0x0E) assign_byte(C);
    	else if(*data==0x1E) assign_byte(E);
    	else if(*data==0x2E) { flushpair(H,L); output("*byteptr(%s) = 0x%02X;", pairname(H,L), b1); ++data; }
    	else if(*data==0x3E) assign_byte(A);
    	
    	else if(*data==0x0F) { assign(A, new expr_rcr(A)); }
    	else if(*data==0x1F) { assign(A, new expr_ror(A)); }
    	else if(*data==0x2F) { assign(A, new expr_not(A)); }
    	else if(*data==0x3F) { output("CF ^= 1;"); }
    	
    	else if(*data==0x40) B=B; else if(*data==0x41) B=C; else if(*data==0x42) B=D;        else if(*data==0x43) B=E;
    	else if(*data==0x44) B=H; else if(*data==0x45) B=L; else if(*data==0x46) B=PEEK(HL); else if(*data==0x47) B=A;
    	else if(*data==0x48) C=B; else if(*data==0x49) C=C; else if(*data==0x4A) C=D;        else if(*data==0x4B) C=E;
    	else if(*data==0x4C) C=H; else if(*data==0x4D) C=L; else if(*data==0x4E) C=PEEK(HL); else if(*data==0x4F) C=A;
    	else if(*data==0x50) D=B; else if(*data==0x51) D=C; else if(*data==0x52) D=D;        else if(*data==0x53) D=E;
    	else if(*data==0x54) D=H; else if(*data==0x55) D=L; else if(*data==0x56) D=PEEK(HL); else if(*data==0x57) D=A;
    	else if(*data==0x58) E=B; else if(*data==0x59) E=C; else if(*data==0x5A) E=D;        else if(*data==0x5B) E=E;
    	else if(*data==0x5C) E=H; else if(*data==0x5D) E=L; else if(*data==0x5E) E=PEEK(HL); else if(*data==0x5F) E=A;
    	else if(*data==0x60) H=B; else if(*data==0x61) H=C; else if(*data==0x62) H=D;        else if(*data==0x63) H=E;
    	else if(*data==0x64) H=H; else if(*data==0x65) H=L; else if(*data==0x66) H=PEEK(HL); else if(*data==0x67) H=A;
    	else if(*data==0x68) L=B; else if(*data==0x69) L=C; else if(*data==0x6A) L=D;        else if(*data==0x6B) L=E;
    	else if(*data==0x6C) L=H; else if(*data==0x6D) L=L; else if(*data==0x6E) L=PEEK(HL); else if(*data==0x6F) L=A;
    	
    	else if(*data==0x70) PEEK(HL) = B;
    	else if(*data==0x71) PEEK(HL) = C;
    	else if(*data==0x72) PEEK(HL) = D;
    	else if(*data==0x73) PEEK(HL) = E;
    	else if(*data==0x74) PEEK(HL) = H;
    	else if(*data==0x75) PEEK(HL) = L;
    	else if(*data==0x76) HALT(); /* wait for irq and save power */;
    	else if(*data==0x77) PEEK(HL) = A;
    	
    	else if(*data==0x78) A=B; else if(*data==0x79) A=C; else if(*data==0x7A) A=D;        else if(*data==0x7B) A=E;
    	else if(*data==0x7C) A=H; else if(*data==0x7D) A=L; else if(*data==0x7E) A=PEEK(HL); else if(*data==0x7F) A=A;
    	
    	else if(*data==0x80) A=A+B;
    	else if(*data==0x81) A=A+C;
    	else if(*data==0x82) A=A+D;
    	else if(*data==0x83) A=A+E;
    	else if(*data==0x84) A=A+H;
    	else if(*data==0x85) A=A+L;
    	else if(*data==0x86) A=A+PEEK(HL);
    	else if(*data==0x87) A=A+A;
    	
    	else if(*data==0x88) A=ADC(A,B);
    	else if(*data==0x89) A=ADC(A,C);
    	else if(*data==0x8A) A=ADC(A,D);
    	else if(*data==0x8B) A=ADC(A,E);
    	else if(*data==0x8C) A=ADC(A,H);
    	else if(*data==0x8D) A=ADC(A,L);
    	else if(*data==0x8E) A=ADC(A,PEEK(HL));
    	else if(*data==0x8F) A=ADC(A,A);
    	
    	else if(*data==0x90) A=A-B;
    	else if(*data==0x91) A=A-C;
    	else if(*data==0x92) A=A-D;
    	else if(*data==0x93) A=A-E;
    	else if(*data==0x94) A=A-H;
    	else if(*data==0x95) A=A-L;
    	else if(*data==0x96) A=A-PEEK(HL);
    	else if(*data==0x97) A=A-A;
    	
    	else if(*data==0x98) A=SBB(A,B);
    	else if(*data==0x99) A=SBB(A,C);
    	else if(*data==0x9A) A=SBB(A,D);
    	else if(*data==0x9B) A=SBB(A,E);
    	else if(*data==0x9C) A=SBB(A,H);
    	else if(*data==0x9D) A=SBB(A,L);
    	else if(*data==0x9E) A=SBB(A,PEEK(HL));
    	else if(*data==0x9F) A=SBB(A,A);
    	
    	else if(*data==0xA0) A=SBB(A,B);
    	else if(*data==0xA1) A=SBB(A,C);
    	else if(*data==0xA2) A=SBB(A,D);	
    	else if(*data==0xA3) A=SBB(A,E);
    	else if(*data==0xA4) A=SBB(A,H);
    	else if(*data==0xA5) A=SBB(A,L);
    	else if(*data==0xA6) A=SBB(A,PEEK(HL));
    	else if(*data==0xA7) A=SBB(A,A));
    	
    	else if(*data==0xA8) A=XOR(A,B));
    	else if(*data==0xA9) A=XOR(A,C));
    	else if(*data==0xAA) A=XOR(A,D));
    	else if(*data==0xAB) A=XOR(A,E));
    	else if(*data==0xAC) A=XOR(A,H));
    	else if(*data==0xAD) A=XOR(A,L));
    	else if(*data==0xAE) A=XOR(A,PEEK(HL));
    	else if(*data==0xAF) A=XOR(A,A));
    	
    	else if(*data==0xB0) A=OR(A,B));
    	else if(*data==0xB1) A=OR(A,C));
    	else if(*data==0xB2) A=OR(A,D));
    	else if(*data==0xB3) A=OR(A,E));
    	else if(*data==0xB4) A=OR(A,H));
    	else if(*data==0xB5) A=OR(A,L));
    	else if(*data==0xB6) A=OR(A,PEEK(HL));
    	else if(*data==0xB7) A=OR(A,A));
    	
    	else if(*data==0xB8) A-B;
    	else if(*data==0xB9) A-C;
    	else if(*data==0xBA) A-D;
    	else if(*data==0xBB) A-E;
    	else if(*data==0xBC) A-H;
    	else if(*data==0xBD) A-L;
    	else if(*data==0xBE) A-PEEK(HL);
    	else if(*data==0xBF) A-A;
    	
    	else if(*data==0xC0) { if(!ZF)RET(); }
    	else if(*data==0xD0) { if(!CF)RET(); }
    	else if(*data==0xE0) { ++data; PEEK(b1|0xFF00) = A; }
    	else if(*data==0xF0) { ++data; A = PEEK(b1|0xFF00); }
    	else if(*data==0xE2) PEEK(0xFF00|C) = A;
    	else if(*data==0xF2) A = PEEK(0xFF00|C);
    	
    	else if(*data==0xC1) POP(BC); else if(*data==0xC5) PUSH(BC);
    	else if(*data==0xD1) POP(DE); else if(*data==0xD5) PUSH(DE);
    	else if(*data==0xE1) POP(HL); else if(*data==0xE5) PUSH(HL);
    	else if(*data==0xF1) POP(AF); else if(*data==0xF5) PUSH(AF);    	
    	
    	/* D3, E3 = nothing */
    	else if(*data==0xF3) DISABLE(); /* CLI */
    	
    	else if(*data==0xC4) { if(!ZF)CALL(w);
    	else if(*data==0xD4) { if(!CF)CALL(w); }
    	/* E4, F4 = nothing */
    	
    	
    	else if(*data==0xC6) { ++data; A=A+b1; }
    	else if(*data==0xD6) { ++data; A=A-b1; }
    	else if(*data==0xE6) { ++data; A=SBB(A, b1)); }
    	else if(*data==0xF6) { ++data; A=OR(A, b1)); }
    	
    	else if(*data==0xC7) CALL(0*8); /* RST 00 */
    	else if(*data==0xD7) CALL(2*8); /* RST 10 */
    	else if(*data==0xE7) CALL(4*8); /* RST 20 */
    	else if(*data==0xF7) CALL(6*8); /* RST 30 */

    	else if(*data==0xC8) { if(ZF)RET(); }
    	else if(*data==0xD8) { if(CF)RET(); }
    	else if(*data==0xE8) SP += (signed char)b1);
    	else if(*data==0xF8) HL = SP + (signed char)b1;
    	
    	else if(*data==0xC9) RET();
    	else if(*data==0xD9) IRET();
    	else if(*data==0xF9) SP=HL;

    	else if(*data==0xEA) { data+=2; PEEK(w) = A; }
    	else if(*data==0xFA) { data+=2; A = PEEK(w); }
    	
    	else if(*data==0xCB)
    	{
    		++data;
    		     if(b1==0x00) B = RCL(B);
    		else if(b1==0x01) C = RCL(C);
    		else if(b1==0x02) D = RCL(D);
    		else if(b1==0x03) E = RCL(E);
    		else if(b1==0x04) H = RCL(H);
    		else if(b1==0x05) L = RCL(L);
    		else if(b1==0x06) PEEK(HL) = RCL(PEEK(HL));
    		else if(b1==0x07) A = RCL(A);
    		else if(b1==0x08) B = RCR(B);
    		else if(b1==0x09) C = RCR(C);
    		else if(b1==0x0A) D = RCR(D);
    		else if(b1==0x0B) E = RCR(E);
    		else if(b1==0x0C) H = RCR(H);
    		else if(b1==0x0D) L = RCR(L);
    		else if(b1==0x0E) PEEK(HL) = RCR(PEEK(HL));
    		else if(b1==0x0F) A = RCR(A);
    		else if(b1==0x10) B = ROL(B);
    		else if(b1==0x11) C = ROL(C);
    		else if(b1==0x12) D = ROL(D);
    		else if(b1==0x13) E = ROL(E);
    		else if(b1==0x14) H = ROL(H);
    		else if(b1==0x15) L = ROL(L);
    		else if(b1==0x16) PEEK(HL) = ROL(PEEK(HL));
    		else if(b1==0x17) A = ROL(A);
    		else if(b1==0x18) B = ROR(B);
    		else if(b1==0x19) C = ROR(C);
    		else if(b1==0x1A) D = ROR(D);
    		else if(b1==0x1B) E = ROR(E);
    		else if(b1==0x1C) H = ROR(H);
    		else if(b1==0x1D) L = ROR(L);
    		else if(b1==0x1E) PEEK(HL) = ROR(PEEK(HL));
    		else if(b1==0x1F) A = ROR(A);
    		else if(b1==0x20) B = SHL(B);
    		else if(b1==0x21) C = SHL(C);
    		else if(b1==0x22) D = SHL(D);
    		else if(b1==0x23) E = SHL(E);
    		else if(b1==0x24) H = SHL(H);
    		else if(b1==0x25) L = SHL(L);
    		else if(b1==0x26) PEEK(HL) = SHL(PEEK(HL));
    		else if(b1==0x27) A = SHL(A);
    		else if(b1==0x28) B = SAR(A);
    		else if(b1==0x29) C = SAR(C);
    		else if(b1==0x2A) D = SAR(D);
    		else if(b1==0x2B) E = SAR(E);
    		else if(b1==0x2C) H = SAR(H);
    		else if(b1==0x2D) L = SAR(L);
    		else if(b1==0x2E) PEEK(HL) = SAR(PEEK(HL));
    		else if(b1==0x2F) A = SAR(A);
    		else if(b1==0x30) B = SWAP(B);
    		else if(b1==0x31) C = SWAP(C);
    		else if(b1==0x32) D = SWAP(D);
    		else if(b1==0x33) E = SWAP(E);
    		else if(b1==0x34) H = SWAP(H);
    		else if(b1==0x35) L = SWAP(L);
    		else if(b1==0x36) PEEK(HL) = SWAP(PEEK(HL));
    		else if(b1==0x37) A = SWAP(A);
    		else if(b1==0x38) B = SHR(B);
    		else if(b1==0x39) C = SHR(C);
    		else if(b1==0x3A) D = SHR(D);
    		else if(b1==0x3B) E = SHR(E);
    		else if(b1==0x3C) H = SHR(H);
    		else if(b1==0x3D) L = SHR(L);
    		else if(b1==0x3E) PEEK(HL) = SHR(PEEK(HL));
    		else if(b1==0x3F) A = SHR(A);
    		else
    		{
    			expr **tm = NULL;
    			switch(b1&7)
    			{
    				case 0: tm = &B; break;
    				case 1: tm = &C; break;
    				case 2: tm = &D; break;
    				case 3: tm = &E; break;
    				case 4: tm = &H; break;
    				case 5: tm = &L; break;
    				case 7: tm = &A; break;
    			}
    			if(!tm)
    			{
    				flush(H);
    				flush(L);
    				switch(b1 & 0xF8)
    				{
        				case 0x40: PEEK(HL) = XOR(PEEK(HL), 1<<0); break;
        				case 0x78: PEEK(HL) = XOR(PEEK(HL), 1<<1); break;
        				case 0xB0: PEEK(HL) = XOR(PEEK(HL), 1<<2); break;
        				case 0xE8: PEEK(HL) = XOR(PEEK(HL), 1<<3); break;
        				case 0x60: PEEK(HL) = XOR(PEEK(HL), 1<<4); break;
        				case 0x98: PEEK(HL) = XOR(PEEK(HL), 1<<5); break;
        				case 0xD0: PEEK(HL) = XOR(PEEK(HL), 1<<6); break;
        				case 0x48: PEEK(HL) = XOR(PEEK(HL), 1<<7); break;
        				
        				case 0x80: PEEK(HL) = AND(PEEK(HL), (1<<0)^255); break;
        				case 0xB8: PEEK(HL) = AND(PEEK(HL), (1<<1)^255); break;
        				case 0xF0: PEEK(HL) = AND(PEEK(HL), (1<<2)^255); break;
        				case 0x68: PEEK(HL) = AND(PEEK(HL), (1<<3)^255); break;
        				case 0xA0: PEEK(HL) = AND(PEEK(HL), (1<<4)^255); break;
        				case 0xD8: PEEK(HL) = AND(PEEK(HL), (1<<5)^255); break;
        				case 0x50: PEEK(HL) = AND(PEEK(HL), (1<<6)^255); break;
        				case 0x88: PEEK(HL) = AND(PEEK(HL), (1<<7)^255); break;
        				                                                       
        				case 0xC0: PEEK(HL) = OR(PEEK(HL), 1<<0); break;
        				case 0xF8: PEEK(HL) = OR(PEEK(HL), 1<<1); break;
        				case 0x70: PEEK(HL) = OR(PEEK(HL), 1<<2); break;
        				case 0xA8: PEEK(HL) = OR(PEEK(HL), 1<<3); break;
        				case 0xE0: PEEK(HL) = OR(PEEK(HL), 1<<4); break;
        				case 0x58: PEEK(HL) = OR(PEEK(HL), 1<<5); break;
        				case 0x90: PEEK(HL) = OR(PEEK(HL), 1<<6); break;
        				case 0xC8: PEEK(HL) = OR(PEEK(HL), 1<<7); break;
        			}
        		}
    			else
    				switch(b1 & 0xF8)
    				{
        				case 0x40: *tm = XOR(*tm, 1<<0)); break;
        				case 0x78: *tm = XOR(*tm, 1<<1)); break;
        				case 0xB0: *tm = XOR(*tm, 1<<2)); break;
        				case 0xE8: *tm = XOR(*tm, 1<<3)); break;
        				case 0x60: *tm = XOR(*tm, 1<<4)); break;
        				case 0x98: *tm = XOR(*tm, 1<<5)); break;
        				case 0xD0: *tm = XOR(*tm, 1<<6)); break;
        				case 0x48: *tm = XOR(*tm, 1<<7)); break;
        				
        				case 0x80: *tm = AND(*tm, (1<<0)^255)); break;     
        				case 0xB8: *tm = AND(*tm, (1<<1)^255)); break;     
        				case 0xF0: *tm = AND(*tm, (1<<2)^255)); break;     
        				case 0x68: *tm = AND(*tm, (1<<3)^255)); break;     
        				case 0xA0: *tm = AND(*tm, (1<<4)^255)); break;     
        				case 0xD8: *tm = AND(*tm, (1<<5)^255)); break;     
        				case 0x50: *tm = AND(*tm, (1<<6)^255)); break;     
        				case 0x88: *tm = AND(*tm, (1<<7)^255)); break;     
        				                                                       
        				case 0xC0: *tm = OR(*tm, 1<<0)); break;            
        				case 0xF8: *tm = OR(*tm, 1<<1)); break;            
        				case 0x70: *tm = OR(*tm, 1<<2)); break;            
        				case 0xA8: *tm = OR(*tm, 1<<3)); break;            
        				case 0xE0: *tm = OR(*tm, 1<<4)); break;            
        				case 0x58: *tm = OR(*tm, 1<<5)); break;            
        				case 0x90: *tm = OR(*tm, 1<<6)); break;            
        				case 0xC8: *tm = OR(*tm, 1<<7)); break;            
        			}
    		}                                                              
    	}
    	                                                                   
    	/* DB, EB = nothing */
    	else if(*data==0xFB) { ENABLE(); }
    	
    	else if(*data==0xCC) { data+=2; if(ZF)CALL(w); }
    	else if(*data==0xDC) { data+=2; if(CF)CALL(w); }
    	/* EC, FC = nothing */
    	
    	else if(*data==0xCD) { data+=2; CALL(w); }
    	/* DD, ED, FD = nothing */
    	
    	else if(*data==0xCE) { ++data; A = ADC(A, b1); }
    	else if(*data==0xDE) { ++data; A = SBC(A, b1); }
    	else if(*data==0xEE) { ++data; A = XOR(A, b1); }
    	else if(*data==0xFE) { ++data; SUBTRACT(A, b1); }
    	
    	else if(*data==0xCF) CALL(1*8); /* RST 08 */
    	else if(*data==0xDF) CALL(3*8); /* RST 18 */
    	else if(*data==0xEF) CALL(5*8); /* RST 28 */
    	else if(*data==0xFF) CALL(7*8); /* RST 38 */
    	else
    		OPCODE(*data);
    		
    	++data;
    }
}
